<template>
  <article id="post" class="container">
    <div class="row">
      <template v-if="!isLoaded">load...</template>
      <template v-else>
        <header class="col-12">
          <h1>{{ news.title }}</h1>
          <img :src="getImg(news)" :alt="news.title" style="width: 100%">
        </header>
        <section class="col-12">
          <p>{{ news.content }}</p>
        </section>
      </template>
    </div>

  </article>
  
</template>

<script>
  import { mapState, mapActions } from 'vuex'

  import defImg from '@/assets/js/mixin_defaultImg'

  export default {
    name: "SingleNews",
    mixins: [ defImg ],
    data() { return {} },

    beforeRouteLeave (to, from, next) {
      /* при переходе на другую страницу, вызываем мутации для сброса состояния одной новости */
      this.$store.commit('SET_SINGLE_IS_LOADED', false)
      this.$store.commit('SET_SINGLE_NEWS', {})
      next()
    },
    async created() {
      /* полчаем переданный параметр с предыдущей страницы (id новости) и вызываем
      действие которое сделает запрос к серверу и сохранит нужную новость в состояние */
      const curNewsId = this.$route.params.id
      await this.getNews(curNewsId)
    },
    computed: {
      ...mapState({
        isLoaded: ({ isSingleLoaded }) => isSingleLoaded,
        news: ({ singleNews }) => singleNews[0]
      })
    },
    methods: {
      ...mapActions({
        getNews: 'GET_SINGLE_NEWS'
      })
    }

  }


</script>

<style lang="sass">

</style>